/* list datatype for ToolAlias */

struct toollist {
	struct toollist *prev, *next;
	char *oldname;
	char *newname;
};

typedef struct toollist TOOL;

/* prototypes for functions defined in list.c */
void free_tool(TOOL *tool);
TOOL *get_head(void);
TOOL *get_tail(void);
TOOL *add_tool(TOOL *curtool);
TOOL *rem_tool(TOOL *tool);
BOOL set_oldname(TOOL *tool, char *oldname);
BOOL set_newname(TOOL *tool, char *newname);
char *find_tool(char *name);
void free_list(void);
